﻿using SciChart.Charting.ChartModifiers;
using SciChart.Charting.Model.ChartSeries;
using SciChart.Charting.Model.DataSeries;
using SciChart.Charting.Visuals.PointMarkers;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Windows.Media;

namespace SciChartSample
{
    public class MainWindowViewModel
    {
        public List<IRenderableSeriesViewModel> Seriess { get; set; }
        public ObservableCollection<DataPointInfo> SelectedPoints { get; set; }

        public List<IRenderableSeriesViewModel> Seriess2 { get; set; }
        public ObservableCollection<DataPointInfo> SelectedPoints2 { get; set; }

        public MainWindowViewModel()
        {
            Seriess = new List<IRenderableSeriesViewModel>();
            Seriess2 = new List<IRenderableSeriesViewModel>();
            SelectedPoints = new ObservableCollection<DataPointInfo>();
            SelectedPoints2 = new ObservableCollection<DataPointInfo>();

            for (var i = 0; i < 10; i++)
            {
                var item = new XyDataSeries<double>() { SeriesName = $"Name{i}" };
                item.Append(i, i, new PointMetadata());

                var series = new XyScatterRenderableSeriesViewModel()
                {
                    DataSeries = item,
                    PointMarker = new EllipsePointMarker()
                    {
                        Width = 11,
                        Height = 11,
                        Fill = Colors.Blue,
                        Stroke = Colors.Blue
                    },
                    SelectedPointMarker = new EllipsePointMarker()
                    {
                        Width = 13,
                        Height = 13,
                        Fill = Colors.Red,
                        Stroke = Colors.Red
                    },
                    Stroke = Colors.Green,
                    StrokeThickness = 0
                };
                Seriess.Add(series);

                var series2 = new XyScatterRenderableSeriesViewModel()
                {
                    DataSeries = item,
                    PointMarker = new SquarePointMarker()
                    {
                        Width = 11,
                        Height = 11,
                        Fill = Colors.Blue,
                        Stroke = Colors.Blue
                    },
                    SelectedPointMarker = new SquarePointMarker()
                    {
                        Width = 13,
                        Height = 13,
                        Fill = Colors.Red,
                        Stroke = Colors.Red
                    },
                    Stroke = Colors.Green,
                    StrokeThickness = 0
                };
                Seriess2.Add(series2);
            }
        }

        public class PointMetadata : IPointMetadata
        {
            public bool IsSelected { get; set; }
            public event PropertyChangedEventHandler PropertyChanged;
        }
    }
}